import pytest

from days.day_10 import is_corrupted, autocomplete

navigation_subsystem = ['[({(<(())[]>[[{[]{<()<>>',
                        '[(()[<>])]({[<{<<[]>>(',
                        '{([(<{}[<>[]}>{[]{[(<()>',
                        '(((({<>}<{<{<>}{[]{[]{}',
                        '[[<[([]))<([[{}[[()]]]',
                        '[{[{({}]{}}([{[{{{}}([]',
                        '{<[[]]>}<{[{[{[]{()[[[]',
                        '[<(<(<(<{}))><([]([]()',
                        '<{([([[(<>()){}]>(<<{{',
                        '<{([{{}}[<[[[<>{}]]]>[]]']


@pytest.mark.parametrize('line, expected', [
    ('[({(<(())[]>[[{[]{<()<>>', (False, 0)),
    ('[(()[<>])]({[<{<<[]>>(', (False, 0)),
    ('{([(<{}[<>[]}>{[]{[(<()>', (True, 1197)),
    ('(((({<>}<{<{<>}{[]{[]{}', (False, 0)),
    ('[[<[([]))<([[{}[[()]]]', (True, 3)),
    ('[{[{({}]{}}([{[{{{}}([]', (True, 57)),
    ('{<[[]]>}<{[{[{[]{()[[[]', (False, 0)),
    ('[<(<(<(<{}))><([]([]()', (True, 3)),
    ('<{([([[(<>()){}]>(<<{{', (True, 25137)),
    ('<{([{{}}[<[[[<>{}]]]>[]]', (False, 0))
])
def test_is_corrupted(line, expected):
    actual = is_corrupted(line)

    assert actual == expected


@pytest.mark.parametrize('line, expected', [
    ('[({(<(())[]>[[{[]{<()<>>', ('}}]])})]', 288957)),
    ('[(()[<>])]({[<{<<[]>>(', (')}>]})', 5566)),
    ('(((({<>}<{<{<>}{[]{[]{}', ('}}>}>))))', 1480781)),
    ('{<[[]]>}<{[{[{[]{()[[[]', (']]}}]}]}>', 995444)),
    ('<{([{{}}[<[[[<>{}]]]>[]]', ('])}>', 294))
])
def test_autocomplete(line, expected):
    actual = autocomplete(line)

    assert actual == expected
